/**
 * See the NOTICE file distributed with this work
 * for additional information regarding copyright ownership.
 * Board of Regents of the University of Wisconsin System
 * licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a
 * copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
/**
 * 
 */

package com.microsoft.exchange.impl;

import org.springframework.ws.context.MessageContext;
import org.springframework.ws.soap.SoapMessage;

import com.microsoft.exchange.types.ConnectingSIDType;

/**
 * Source for {@link ConnectingSIDType}.
 * Used in conjunction with the {@link ExchangeImpersonationClientInterceptor}.
 * 
 * @author Nicholas Blair
 */
public interface ImpersonationConnectingSIDSource {

	/**
	 * 
	 * @param soapMessage
	 * @param messageContext
	 * @return the {@link ConnectingSIDType} that should be applied to the header
	 */
	ConnectingSIDType getConnectingSID(SoapMessage soapMessage, MessageContext messageContext);
}
